﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;

using System.IO;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Hosting;

namespace Web_API_File_Upload_MVC_Core.Controllers
{
    [Route("api/[controller]")]
    [ApiController]
    public class FileAPIController : ControllerBase
    {
        private IHostingEnvironment Environment;

        public FileAPIController(IHostingEnvironment _environment)
        {
            Environment = _environment;
        }

        [Route("UploadFiles")]
        [HttpPost]
        public IActionResult UploadFiles()
        {
            //Create the Directory.
            string path = Path.Combine(this.Environment.WebRootPath, "Uploads\\");
            if (!Directory.Exists(path))
            {
                Directory.CreateDirectory(path);
            }

            //Fetch the File.
            IFormFile postedFile = Request.Form.Files[0];

            //Fetch the File Name.
            string fileName = Request.Form["fileName"] + Path.GetExtension(postedFile.FileName);

            //Save the File.
            using (FileStream stream = new FileStream(Path.Combine(path, fileName), FileMode.Create))
            {
                postedFile.CopyTo(stream);
            }

            //Send OK Response to Client.
            return Ok(fileName);
        }
    }
}
